 <?php

//ini_set('display_errors',1);
//error_reporting(E_ALL|E_STRICT);
//echo '<pre>'.print_r($GLOBALS).'</pre>';
$TITLE_EXTRA=': News';
$RSS = '{TEMPLATE: news_RSS}';
 /*{PRE_HTML_PHP}*/
/* FUNCTIONS FROM FUDAPI STOLD */
function _fud_msg_multi($arg, $query)
{
	$arg = is_numeric($arg) ? array($arg) : (int) $arg;
	$ids = array();
	$r = uq(str_replace('{ARG}', implode(',', $arg), $query));
	while ($row = db_rowarr($r)) {
		$ids[] = $row[0];
	}
	if (!$ids) {
		return FALSE;
	}

	return fud_fetch_msg($ids);
}


function fud_fetch_msg($arg)
{
	$arg = is_numeric($arg) ? array($arg) : $arg;

	$result = array();
	$c = q("SELECT
		m.*,
		t.forum_id,
		u.alias AS login, u.avatar_loc, u.email, u.posted_msg_count, u.join_date, u.location,
		u.sig, u.custom_status, u.icq, u.jabber, u.affero, u.aim, u.msnm, u.yahoo, u.users_opt, u.last_visit AS time_sec,
		l.name AS level_name, l.img AS level_img
	FROM
		".$GLOBALS['DBHOST_TBL_PREFIX']."msg m
		INNER JOIN ".$GLOBALS['DBHOST_TBL_PREFIX']."thread t ON m.thread_id=t.id
		LEFT JOIN ".$GLOBALS['DBHOST_TBL_PREFIX']."users u ON m.poster_id=u.id
		LEFT JOIN ".$GLOBALS['DBHOST_TBL_PREFIX']."level l ON u.level_id=l.id
		WHERE m.id IN (".implode(',', $arg).") AND m.apr=1");

	while ($r = db_rowobj($c)) {
		if ($r->poll_cache && $r->poll_id) {
			$r->poll_data = fud_fetch_poll($r->poll_id);
			unset($r->poll_data->alias, $r->poll_data->owner);
		}
		if ($r->attach_cnt && !empty($r->attach_cache)) {
			$tmp = @unserialize($r->attach_cache);
			$alist = array();
			foreach ($tmp as $v) {
				$alist[] = $v[0];
			}
			$r->attachments = fud_fetch_attachment($alist);
		}
		$r->body = read_msg_body($r->foff, $r->length, $r->file_id);
		unset(
			$r->foff, $r->length, $r->file_id, $r->offset_preview, $r->length_preview, $r->file_id_preview,
			$r->attach_cache, $r->poll_cache, $r->apr, $r->msg_opt
		);
		$result[] = $r;
	}
	unset($c, $r);

	if (count($result) != count($arg)) {
		return FALSE;
	} else {
	//	if (count($result) == 1) {
	//		return array_pop($result);
	//	} else {
			return $result;
	//	}
	}
}


function fud_fetch_attachment($arg)
{
	$res = _fud_simple_fetch_query($arg, "SELECT 
			a.*, u.alias, m.mime_hdr, m.descr, m.icon 
			FROM ".$GLOBALS['DBHOST_TBL_PREFIX']."attach a 
			LEFT JOIN ".$GLOBALS['DBHOST_TBL_PREFIX']."users u ON u.id=a.owner
			LEFT JOIN ".$GLOBALS['DBHOST_TBL_PREFIX']."mime m ON m.id=a.mime_type
			WHERE a.id IN({ARG})");

	if (is_array($res)) {
		foreach ($res as $k => $v) {
			$res[$k]->download_url = $GLOBALS['WWW_ROOT'].'index.php?t=getfile&amp;id='.$v->id;
			unset($res[$k]->attach_opt);
		}
	} else {
		$res->download_url = $GLOBALS['WWW_ROOT'].'index.php?t=getfile&amp;id='.$res->id;
		unset($res->attach_opt);
	}
	return $res;
}


function _fud_simple_fetch_query($arg, $query)
{
        if ($arg) {    
		$arg = is_numeric($arg) ? array($arg) : $arg;
	} else {
		$arg = array();
	}
	$result = array();

	$r = uq(str_replace('{ARG}', implode(',', $arg), $query));
	while ($row = db_rowobj($r)) {
		$result[] = $row;
	}
	unset($r);

	if ($arg && count($result) != count($arg)) {
		return FALSE;
	} else {
		if (count($result) == 1) {
			return array_pop($result);
		} else {
			return $result;
		}
	}
}

function fud_fetch_topic($arg)
{
// echo "<pre>".$arg."</pre>";
	$arg = is_numeric($arg) ? array($arg) : $arg;

	$result = array();	

	$c = uq("SELECT
		m.attach_cnt, m.poll_id, m.subject, m.icon, m.post_stamp,
		u.alias, u.id,
		u2.id, u2.alias,
		m2.id, m2.post_stamp AS last_post_stamp,
		t.id AS topic_id, t.moved_to, t.root_msg_id, t.replies, t.rating, t.thread_opt, t.views, t.tdescr
		FROM ".$GLOBALS['DBHOST_TBL_PREFIX']."thread t
			INNER JOIN ".$GLOBALS['DBHOST_TBL_PREFIX']."msg	m	ON t.root_msg_id=m.id
			INNER JOIN ".$GLOBALS['DBHOST_TBL_PREFIX']."msg	m2	ON m2.id=t.last_post_id
			LEFT JOIN ".$GLOBALS['DBHOST_TBL_PREFIX']."users	u	ON u.id=m.poster_id
			LEFT JOIN ".$GLOBALS['DBHOST_TBL_PREFIX']."users	u2	ON u2.id=m2.poster_id
			LEFT JOIN ".$GLOBALS['DBHOST_TBL_PREFIX']."read 	r	ON t.id=r.thread_id AND r.user_id='._uid.'
			WHERE t.id IN(".implode(',', $arg).")");

	while ($r = db_rowobj($c)) {
		$r->replies++;
		$r->type = $r->thread_opt > 1 ? ($r->thread_opt & 4 ? 'sticky' : 'announcement') : NULL;
		if ($GLOBALS['FUD_OPT_2'] & 4096 && $r->rating) {
			$r->rating = NULL;
		}
		unset($r->thread_opt);
		$result[] = $r;
	}
	unset($c, $r);

	if (count($result) != count($arg)) {
		return FALSE;
	} else {
		if (count($result) == 1) {
			return array_pop($result);
		} else {
			return $result;
		}
	}
}


/* FUNCTIONS FROM FUDAPI STOLD - DONE */

/* GATHER DATA AND SERVE TO TEMPLATE */

if (isset($_GET['start']) && (is_numeric($_GET['start'])) ) {
$start = $_GET['start'];
$starts = $start.', ';
} else {
$start = '0';
$starts= '';
}
if (isset($_GET['icon'])) {
$filter_icon = mysql_real_escape_string($_GET['icon']);
$filter = 'AND m3.icon=\''.$filter_icon.'\' ';
} else {
$filter_icon = '';
$filter = '';
}
 $topics = _fud_msg_multi(1, "SELECT t3.root_msg_id, m3.icon FROM ".$GLOBALS['DBHOST_TBL_PREFIX']."thread t3 
			INNER JOIN ".$GLOBALS['DBHOST_TBL_PREFIX']."msg m3 ON t3.root_msg_id=m3.id
			WHERE forum_id=118 ".$filter."ORDER BY t3.root_msg_id DESC LIMIT ".$starts."10");
 $topic_count = q_singleval("SELECT COUNT(*) FROM ".$GLOBALS['DBHOST_TBL_PREFIX']."thread WHERE forum_id=118");
 krsort($topics);
 foreach($topics as $topic) {
                if (_uid && ($perms & 16 || (_uid == $topic->poster_id && (!$GLOBALS['EDIT_TIME_LIMIT'] || __request_timestamp__ - $topic->post_stamp < $GLOBALS['EDIT_TIME_LIMIT'] * 60)))) {
                        $edit_link = '{TEMPLATE: news_msg_edit}';
                } else {
                        $edit_link = '';
                }

$user_login = $topic->poster_id ? $topic->login : $GLOBALS['ANON_NICK'];
$topic_id = $topic->thread_id;
$thread = fud_fetch_topic($topic_id);
$comment_count = $thread->replies - 1;
			$thread_read_status = $first_unread_msg_link = '';
			if (_uid && $usr->last_read < $thread->last_post_stamp && $thread->last_post_stamp > $thread->post_stamp) {
				$thread_read_status = ($thread->rating & 1) ? '{TEMPLATE: news_thread_unread_locked}' : '{TEMPLATE: news_thread_unread}';
				/* do not show 1st unread message link if thread has no replies */
				if ($thread->replies) {
					$first_unread_msg_link = '{TEMPLATE: news_first_unread_msg_link}';
				}
			} else if ($thread->rating & 1) {
				$thread_read_status = '{TEMPLATE: news_thread_read_locked}';
			} else if (!_uid) {
				$thread_read_status = '{TEMPLATE: news_thread_read_unreg}';
			} else {
				$thread_read_status = '{TEMPLATE: news_thread_read}';
			}

		$thread_title_SEO = str_replace(" ","-",$topic->subject);
		$thread_title_SEO = strtolower($thread_title_SEO);
		$thread_title_SEO = preg_replace('/[^a-z0-9_]/i', '-', $thread_title_SEO);
		$thread_title_SEO = preg_replace('/_[_]*/i', '-', $thread_title_SEO);
		$thread_title_SEO = str_replace('---', '-', $thread_title_SEO);
		$thread_title_SEO = str_replace('--', '-', $thread_title_SEO);
		$thread_title_SEO = str_replace('-s-', 's-', $thread_title_SEO);
		$thread_title_SEO = str_replace("%","",$thread_title_SEO);


$msg_list .= '{TEMPLATE: news_msg_entry}';
 }
	if ($FUD_OPT_2 & 32768) {
		$page_pager = tmpl_create_pager($start, 10, $topic_count, '{ROOT}/news/', '/' ._rsid);
	} else {
		$page_pager = tmpl_create_pager($start, 10, $topic_count, '{ROOT}?t=news&amp;'._rsid);
	}



$page_data = '{TEMPLATE: news_msg_list}';

 /*{POST_HTML_PHP}*/
 /*{POST_PAGE_PHP_CODE}*/

 ?>
 {TEMPLATE: NEWS_PAGE}
